;Copywrite 2001 by Samuel Stearley  sstear70@calvin.edu
;Feel free to use this



_nostub		;by declaring these labels here i only have to include
_ti89			;  this file and not os.h
_ti92plus



;Extra data items are at an offset of 8 into the event
;structure



;--Some event ids, same name as tigcc documentation----


CM_IDLE		EQU	$700
CM_INIT		EQU	$701
CM_STARTTASK	EQU	$702		;extra data is a rectangle
CM_ACTIVE		EQU	$703
CM_FOCUS		EQU	$704
CM_UNFOCUS		EQU	$705
CM_DEACTIVATE	EQU	$706
CM_ENDTASK		EQU	$707
CM_START_CURRENT	EQU	$708
CM_KEYPRESS		EQU	$710		;2 extra data items-> modifiers and a keypress
CM_MENU_CUT		EQU	$720
CM_MENU_COPY	EQU	$721
CM_MENU_PASTE	EQU	$722
CM_STRING		EQU	$723		;extra data is a pointer to a string
CM_HSTRING		EQU	$724		;extra data is a handle contianing text
CM_DEL		EQU	$725
CM_CLR		EQU	$726
CM_MENU_CLEAR	EQU	$727
CM_MENU_FIND	EQU	$728
CM_INSERT		EQU	$730
CM_BLINK		EQU	$740
CM_STORE		EQU	$750
CM_RECALL		EQU	$751
CM_WPAINT		EQU	$760		;extra data is a pointer to a window
CM_MENU_OPEN	EQU	$770
CM_MENU_SAVE_AS	EQU	$771
CM_MENU_NEW		EQU	$772
CM_MENU_FORMAT	EQU	$773
CM_MENU_ABOUT	EQU	$774
CM_MODE_CHANGE	EQU	$780
CM_SWITCH_GRAPH	EQU	$781
CM_GEOMETRY		EQU	$7C0



;A simple macro that put the processor in an endless loop.  So I
;right click on vti, select "enter debugger" and manually unset the
;carry flag and then I can step through the code.

debug MACRO	
	move #1,ccr
\l:
	bcs.s	\l

 ENDM


;A macro that returns in d0.l the pointer to the home entry line text
;edit structure.  It assumes that a6 contains the pointer to the jump
;table.  It also destroys a0


HomeTextEditStructure MACRO

	move.l	1080(a6),a0
	move.l	708(a6),d0
SearchLoop:
	addq.l	#2,a0
	cmp.l		(a0),d0
	bne.s		SearchLoop
	moveq		#0,d0
	move.w	-4(a0),d0

	ENDM



;A general purpose install macro that copies the tsr to allocated ram
;and links it with the others.
;Inclose your code in Labels called END_OF_HOOK and BEGINNING_OF_HOOK
;And provide a pointer to the event hook place holder named oldHook.

;This macro takes one parameter and that is the success message.


Install MACRO 	;ptr * msg
	movem.l	d3-d7/a2-a6,-(a7)
	move.l	a7,d7
	move.l	200,a6
	move.l	2700(a6),a5
	lea		oldHook(pc),a1
	move.l	(a5),(a1)
	move.l	#END_OF_HOOK-BEGINNING_OF_HOOK,d3
	move.l	d3,-(a7)
	move.l	584(a6),a0
	jsr		(a0)
	pea		errorMessage(pc)
	tst.w		d0
	beq.s		MemoryError
	move.w	d0,-(a7)
	move.l	600(a6),a0
	jsr		(a0)
	move.l	a0,a1
	add.l		#$40010,a0
	move.l	a0,(a5)
	subq.l	#1,d3
	lea		BEGINNING_OF_HOOK(pc),a0
CopyLoop:
	move.b	(a0)+,(a1)+
	dbra		d3,CopyLoop
	pea		\1(pc)
MemoryError:
	move.l	920(a6),a0
	jsr		(a0)
	move.l	d7,a7
	movem.l	(a7)+,d3-d7/a2-a6
	rts

errorMessage:	dc.b	"Not enough memory",0

	ENDM


